unit SDUCheckLst;
// Description: TCheckListBox with ReadOnly property
// By Sarah Dean
// Email: sdean12@sdean12.org
// WWW:   http://www.SDean12.org/
//
// -----------------------------------------------------------------------------
//

interface

uses
  CheckLst;

type
  TSDUCheckListBox = class(TCheckListBox)
  private
    FReadOnly: boolean;
  protected
    procedure SetReadOnly(ro: boolean);
    procedure ClickCheck(); override;
  published
    property ReadOnly: boolean read FReadOnly write SetReadOnly;
  end;

procedure Register;


implementation

uses
  Classes, Graphics;

procedure Register;
begin
  RegisterComponents('SDeanUtils', [TSDUCheckListBox]);
end;

procedure TSDUCheckListBox.SetReadOnly(ro: boolean);
begin
  FReadOnly := ro;

  Enabled := FReadOnly;
  if FReadOnly then
    begin
    Color := clBtnFace;
    end
  else
    begin
    Color := clWindow;
    end;

end;

procedure TSDUCheckListBox.ClickCheck();
var
  i: integer;
begin
  if FReadOnly then
    begin
    for i:=0 to (items.count-1) do
      begin
      if Selected[i] then
        begin
        Checked[i] := not(Checked[i]);
        end;
      end;
    end
  else
    begin
    inherited;
    end;
    
end;

END.

