unit SDUSysUtils;

interface

uses
  SysUtils, Windows;

// Identical to FileAge(filename, datetime) in Delphi 2007
// This function included to allow same API call to be used in Delphi 7
function SDUFileAge(filename: string; var dateTime: TDateTime): boolean;

// Identical to FileAge(filename, datetime) in Delphi 2007
// This function included to allow same API call to be used in Delphi 7
function SDUFileTimestamps(
  const Filename: string;
  var CreationTime: TFileTime;
  var LastAccessTime: TFileTime;
  var LastWriteTime: TFileTime
): boolean;

implementation

function SDUFileAge(filename: string; var dateTime: TDateTime): boolean;
{$IFDEF VER185}
begin
  Result := FileAge(filename, dateTime);
end;
{$ELSE}
var
  age: integer;
  retval: boolean;
begin
  retval := FALSE;

  age := FileAge(filename);
  if (age <> -1) then
    begin
    dateTime := FileDateToDateTime(age);
    retval := TRUE;
    end;

  Result := retval;
end;
{$ENDIF}


function SDUFileTimestamps(
  const Filename: string;
  var CreationTime: TFileTime;
  var LastAccessTime: TFileTime;
  var LastWriteTime: TFileTime
): boolean;
var
  searchRec: TSearchRec;
  retval: boolean;
begin
  retval := FALSE;
{$WARN SYMBOL_PLATFORM OFF}
  if (SysUtils.FindFirst(filename, faAnyFile, searchRec) = 0) then
    begin
    CreationTime   := searchRec.FindData.ftCreationTime;
    LastAccessTime := searchRec.FindData.ftLastAccessTime;
    LastWriteTime  := searchRec.FindData.ftLastWriteTime;
    SysUtils.FindClose(searchRec);
    retval:= TRUE;
    end;
{$WARN SYMBOL_PLATFORM ON}

  Result := retval;
end;

END.

